within ;
package srdecnipumpa
  package parts
    model tlakuZdroj

      pq pq1 annotation (Placement(transformation(extent={{-10,-10},{10,10}})));
    parameter Real tlak;
    equation
      pq1.p = tlak;
      annotation (Icon(graphics={Text(
              extent={{-78,-82},{62,-20}},
              lineColor={0,0,255},
              textString="%tlak"), Text(
              extent={{-100,24},{102,82}},
              lineColor={0,0,255},
              textString="Zdroj")}));
    end tlakuZdroj;

    connector pq
    Real p;
    flow Real q;
    end pq;

    model odpornik

      pq pq1 annotation (Placement(transformation(extent={{-100,-2},{-80,18}}),
            iconTransformation(extent={{-100,-10},{-80,10}})));
      pq pq2 annotation (Placement(transformation(extent={{82,-12},{102,8}}),
            iconTransformation(extent={{80,-10},{100,10}})));
    parameter Real R;
    Real dp;
    equation
      pq1.q + pq2.q = 0;
      dp = R*pq1.q;
      dp = pq1.p - pq2.p;
    end odpornik;

    model chlopen

      pq pq1 annotation (Placement(transformation(extent={{-98,-12},{-78,8}}),
            iconTransformation(extent={{-100,-10},{-80,10}})));
      pq pq2 annotation (Placement(transformation(extent={{84,-10},{104,10}}),
            iconTransformation(extent={{80,-10},{100,10}})));
      annotation (Icon(graphics={Rectangle(extent={{42,98},{66,-100}},
                lineColor={0,0,255}), Polygon(
              points={{-70,88},{-68,-114},{36,-10},{36,8},{-70,88}},
              lineColor={0,0,255},
              smooth=Smooth.None)}));
    Real q;
    Real dp;
    Boolean otevreno;
    Real pruchodnaPromenna;
    equation
      //  otevreno = if pruchodnaPromenna >0 then true else false;

    /*  if pruchodnaPromenna >0 then
    otevreno = true;
  else
    otevreno = false;
  end if;
*/

      pq1.q + pq2.q = 0;
      q = pq1.q;
      dp = pq1.p - pq2.p;

      otevreno = pruchodnaPromenna > 0;

    if otevreno then
      dp = 0;
      q = pruchodnaPromenna;
    else // otevreno = false
      dp = pruchodnaPromenna;
      q = 0;
    end if;

    end chlopen;

    model komora

      pq pq1 annotation (Placement(transformation(extent={{-10,-100},{10,-80}})));
      Modelica.Blocks.Interfaces.RealInput elastance annotation (Placement(transformation(
              extent={{-100,60},{-60,100}}), iconTransformation(extent={{-100,60},{-60,
                100}})));
      annotation (Icon(graphics={Ellipse(extent={{78,100},{-86,-92}}, lineColor={0,0,
                  255})}));
    Real objem;
    parameter Real pExt(final unit = "Pa")= -4*133;
    equation
     pq1.q = der(objem);

     pq1.p = objem*elastance + pExt;
    end komora;

  connector RealDiscreteOutput =
                         discrete output Real "'output Real' as connector"
    annotation (defaultComponentName="y",
    Icon(coordinateSystem(
          preserveAspectRatio=true,
          extent={{-100,-100},{100,100}},
          grid={1,1}), graphics={Polygon(
            points={{-100,100},{100,0},{-100,-100},{-100,100}},
            lineColor={0,0,127},
            fillColor={255,255,255},
            fillPattern=FillPattern.Solid)}),
    Diagram(coordinateSystem(
          preserveAspectRatio=true,
          extent={{-100,-100},{100,100}},
          grid={1,1}), graphics={Polygon(
            points={{-100,50},{0,0},{-100,-50},{-100,50}},
            lineColor={0,0,127},
            fillColor={255,255,255},
            fillPattern=FillPattern.Solid), Text(
            extent={{30,110},{30,60}},
            lineColor={0,0,127},
            textString="%name")}),
      Documentation(info="<html>
<p>
Connector with one output signal of type Real.
</p>
</html>"));
  connector RealDzksOutput =
                         discrete output Real "'output Real' as connector"
    annotation (defaultComponentName="y",
    Icon(coordinateSystem(
          preserveAspectRatio=true,
          extent={{-100,-100},{100,100}},
          grid={1,1}), graphics={Polygon(
            points={{-100,100},{100,0},{-100,-100},{-100,100}},
            lineColor={0,0,127},
            fillColor={255,255,255},
            fillPattern=FillPattern.Solid)}),
    Diagram(coordinateSystem(
          preserveAspectRatio=true,
          extent={{-100,-100},{100,100}},
          grid={1,1}), graphics={Polygon(
            points={{-100,50},{0,0},{-100,-50},{-100,50}},
            lineColor={0,0,127},
            fillColor={255,255,255},
            fillPattern=FillPattern.Solid), Text(
            extent={{30,110},{30,60}},
            lineColor={0,0,127},
            textString="%name")}),
      Documentation(info="<html>
<p>
Connector with one output signal of type Real.
</p>
</html>"));
  end parts;
  annotation (uses(Modelica(version="3.2")));
  model pumpovani
    parts.tlakuZdroj tlakuZdroj(tlak=0)
      annotation (Placement(transformation(extent={{-100,-2},{-80,18}})));
    parts.tlakuZdroj tlakuZdroj1(tlak=12)
      annotation (Placement(transformation(extent={{80,-2},{100,18}})));
    parts.odpornik odpornik(R=1)
      annotation (Placement(transformation(extent={{-72,-2},{-52,18}})));
    parts.odpornik odpornik1(R=1)
      annotation (Placement(transformation(extent={{58,-2},{78,18}})));
    parts.chlopen chlopen
      annotation (Placement(transformation(extent={{-40,-2},{-20,18}})));
    parts.chlopen chlopen1
      annotation (Placement(transformation(extent={{20,-2},{40,18}})));
    parts.komora komora
      annotation (Placement(transformation(extent={{-10,40},{10,60}})));
    Modelica.Blocks.Sources.Sine sine(freqHz=1, offset=1.5)
      annotation (Placement(transformation(extent={{-78,48},{-58,68}})));
  equation
    connect(sine.y, komora.elastance) annotation (Line(
        points={{-57,58},{-8,58}},
        color={0,0,127},
        smooth=Smooth.None));
    connect(odpornik.pq2, chlopen.pq1) annotation (Line(
        points={{-53,8},{-39,8}},
        color={0,0,255},
        smooth=Smooth.None));
    connect(chlopen.pq2, chlopen1.pq1) annotation (Line(
        points={{-21,8},{21,8}},
        color={0,0,255},
        smooth=Smooth.None));
    connect(chlopen1.pq2, odpornik1.pq1) annotation (Line(
        points={{39,8},{59,8}},
        color={0,0,255},
        smooth=Smooth.None));
    connect(odpornik1.pq2, tlakuZdroj1.pq1) annotation (Line(
        points={{77,8},{90,8}},
        color={0,0,255},
        smooth=Smooth.None));
    connect(odpornik.pq1, tlakuZdroj.pq1) annotation (Line(
        points={{-71,8},{-90,8}},
        color={0,0,255},
        smooth=Smooth.None));
    connect(komora.pq1, chlopen1.pq1) annotation (Line(
        points={{0,41},{0,8},{21,8}},
        color={0,0,255},
        smooth=Smooth.None));
    annotation (Diagram(graphics));
  end pumpovani;
end srdecnipumpa;
